<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span><a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2.cpdsadapter;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.io.PrintWriter;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.io.Serializable;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.DriverManager;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.sql.SQLException;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.sql.SQLFeatureNotSupportedException;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import java.util.Hashtable;<a name="line.25"></a>
<span class="sourceLineNo">026</span>import java.util.Properties;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import java.util.logging.Logger;<a name="line.27"></a>
<span class="sourceLineNo">028</span><a name="line.28"></a>
<span class="sourceLineNo">029</span>import javax.naming.Context;<a name="line.29"></a>
<span class="sourceLineNo">030</span>import javax.naming.Name;<a name="line.30"></a>
<span class="sourceLineNo">031</span>import javax.naming.NamingException;<a name="line.31"></a>
<span class="sourceLineNo">032</span>import javax.naming.RefAddr;<a name="line.32"></a>
<span class="sourceLineNo">033</span>import javax.naming.Reference;<a name="line.33"></a>
<span class="sourceLineNo">034</span>import javax.naming.Referenceable;<a name="line.34"></a>
<span class="sourceLineNo">035</span>import javax.naming.StringRefAddr;<a name="line.35"></a>
<span class="sourceLineNo">036</span>import javax.naming.spi.ObjectFactory;<a name="line.36"></a>
<span class="sourceLineNo">037</span>import javax.sql.ConnectionPoolDataSource;<a name="line.37"></a>
<span class="sourceLineNo">038</span>import javax.sql.PooledConnection;<a name="line.38"></a>
<span class="sourceLineNo">039</span><a name="line.39"></a>
<span class="sourceLineNo">040</span>import org.apache.commons.dbcp2.BasicDataSource;<a name="line.40"></a>
<span class="sourceLineNo">041</span>import org.apache.commons.dbcp2.DelegatingPreparedStatement;<a name="line.41"></a>
<span class="sourceLineNo">042</span>import org.apache.commons.dbcp2.PStmtKey;<a name="line.42"></a>
<span class="sourceLineNo">043</span>import org.apache.commons.dbcp2.Utils;<a name="line.43"></a>
<span class="sourceLineNo">044</span>import org.apache.commons.pool2.KeyedObjectPool;<a name="line.44"></a>
<span class="sourceLineNo">045</span>import org.apache.commons.pool2.impl.BaseObjectPoolConfig;<a name="line.45"></a>
<span class="sourceLineNo">046</span>import org.apache.commons.pool2.impl.GenericKeyedObjectPool;<a name="line.46"></a>
<span class="sourceLineNo">047</span>import org.apache.commons.pool2.impl.GenericKeyedObjectPoolConfig;<a name="line.47"></a>
<span class="sourceLineNo">048</span><a name="line.48"></a>
<span class="sourceLineNo">049</span>/**<a name="line.49"></a>
<span class="sourceLineNo">050</span> * &lt;p&gt;<a name="line.50"></a>
<span class="sourceLineNo">051</span> * An adapter for JDBC drivers that do not include an implementation of {@link javax.sql.ConnectionPoolDataSource}, but<a name="line.51"></a>
<span class="sourceLineNo">052</span> * still include a {@link java.sql.DriverManager} implementation. &lt;code&gt;ConnectionPoolDataSource&lt;/code&gt;s are not used<a name="line.52"></a>
<span class="sourceLineNo">053</span> * within general applications. They are used by &lt;code&gt;DataSource&lt;/code&gt; implementations that pool<a name="line.53"></a>
<span class="sourceLineNo">054</span> * &lt;code&gt;Connection&lt;/code&gt;s, such as {@link org.apache.commons.dbcp2.datasources.SharedPoolDataSource}. A J2EE container<a name="line.54"></a>
<span class="sourceLineNo">055</span> * will normally provide some method of initializing the &lt;code&gt;ConnectionPoolDataSource&lt;/code&gt; whose attributes are<a name="line.55"></a>
<span class="sourceLineNo">056</span> * presented as bean getters/setters and then deploying it via JNDI. It is then available as a source of physical<a name="line.56"></a>
<span class="sourceLineNo">057</span> * connections to the database, when the pooling &lt;code&gt;DataSource&lt;/code&gt; needs to create a new physical connection.<a name="line.57"></a>
<span class="sourceLineNo">058</span> * &lt;/p&gt;<a name="line.58"></a>
<span class="sourceLineNo">059</span> * &lt;p&gt;<a name="line.59"></a>
<span class="sourceLineNo">060</span> * Although normally used within a JNDI environment, the DriverAdapterCPDS can be instantiated and initialized as any<a name="line.60"></a>
<span class="sourceLineNo">061</span> * bean and then attached directly to a pooling &lt;code&gt;DataSource&lt;/code&gt;. &lt;code&gt;Jdbc2PoolDataSource&lt;/code&gt; can use the<a name="line.61"></a>
<span class="sourceLineNo">062</span> * &lt;code&gt;ConnectionPoolDataSource&lt;/code&gt; with or without the use of JNDI.<a name="line.62"></a>
<span class="sourceLineNo">063</span> * &lt;/p&gt;<a name="line.63"></a>
<span class="sourceLineNo">064</span> * &lt;p&gt;<a name="line.64"></a>
<span class="sourceLineNo">065</span> * The DriverAdapterCPDS also provides &lt;code&gt;PreparedStatement&lt;/code&gt; pooling which is not generally available in jdbc2<a name="line.65"></a>
<span class="sourceLineNo">066</span> * &lt;code&gt;ConnectionPoolDataSource&lt;/code&gt; implementation, but is addressed within the jdbc3 specification. The<a name="line.66"></a>
<span class="sourceLineNo">067</span> * &lt;code&gt;PreparedStatement&lt;/code&gt; pool in DriverAdapterCPDS has been in the dbcp package for some time, but it has not<a name="line.67"></a>
<span class="sourceLineNo">068</span> * undergone extensive testing in the configuration used here. It should be considered experimental and can be toggled<a name="line.68"></a>
<span class="sourceLineNo">069</span> * with the poolPreparedStatements attribute.<a name="line.69"></a>
<span class="sourceLineNo">070</span> * &lt;/p&gt;<a name="line.70"></a>
<span class="sourceLineNo">071</span> * &lt;p&gt;<a name="line.71"></a>
<span class="sourceLineNo">072</span> * The &lt;a href="package-summary.html"&gt;package documentation&lt;/a&gt; contains an example using catalina and JNDI. The<a name="line.72"></a>
<span class="sourceLineNo">073</span> * &lt;a href="../datasources/package-summary.html"&gt;datasources package documentation&lt;/a&gt; shows how to use<a name="line.73"></a>
<span class="sourceLineNo">074</span> * &lt;code&gt;DriverAdapterCPDS&lt;/code&gt; as a source for &lt;code&gt;Jdbc2PoolDataSource&lt;/code&gt; without the use of JNDI.<a name="line.74"></a>
<span class="sourceLineNo">075</span> * &lt;/p&gt;<a name="line.75"></a>
<span class="sourceLineNo">076</span> *<a name="line.76"></a>
<span class="sourceLineNo">077</span> * @since 2.0<a name="line.77"></a>
<span class="sourceLineNo">078</span> */<a name="line.78"></a>
<span class="sourceLineNo">079</span>public class DriverAdapterCPDS implements ConnectionPoolDataSource, Referenceable, Serializable, ObjectFactory {<a name="line.79"></a>
<span class="sourceLineNo">080</span><a name="line.80"></a>
<span class="sourceLineNo">081</span>    private static final String KEY_USER = "user";<a name="line.81"></a>
<span class="sourceLineNo">082</span><a name="line.82"></a>
<span class="sourceLineNo">083</span>    private static final String KEY_PASSWORD = "password";<a name="line.83"></a>
<span class="sourceLineNo">084</span><a name="line.84"></a>
<span class="sourceLineNo">085</span>    private static final long serialVersionUID = -4820523787212147844L;<a name="line.85"></a>
<span class="sourceLineNo">086</span><a name="line.86"></a>
<span class="sourceLineNo">087</span>    private static final String GET_CONNECTION_CALLED = "A PooledConnection was already requested from this source, "<a name="line.87"></a>
<span class="sourceLineNo">088</span>        + "further initialization is not allowed.";<a name="line.88"></a>
<span class="sourceLineNo">089</span><a name="line.89"></a>
<span class="sourceLineNo">090</span>    static {<a name="line.90"></a>
<span class="sourceLineNo">091</span>        // Attempt to prevent deadlocks - see DBCP - 272<a name="line.91"></a>
<span class="sourceLineNo">092</span>        DriverManager.getDrivers();<a name="line.92"></a>
<span class="sourceLineNo">093</span>    }<a name="line.93"></a>
<span class="sourceLineNo">094</span><a name="line.94"></a>
<span class="sourceLineNo">095</span>    /** Description */<a name="line.95"></a>
<span class="sourceLineNo">096</span>    private String description;<a name="line.96"></a>
<span class="sourceLineNo">097</span><a name="line.97"></a>
<span class="sourceLineNo">098</span>    /** Url name */<a name="line.98"></a>
<span class="sourceLineNo">099</span>    private String url;<a name="line.99"></a>
<span class="sourceLineNo">100</span><a name="line.100"></a>
<span class="sourceLineNo">101</span>    /** User name */<a name="line.101"></a>
<span class="sourceLineNo">102</span>    private String userName;<a name="line.102"></a>
<span class="sourceLineNo">103</span><a name="line.103"></a>
<span class="sourceLineNo">104</span>    /** User password */<a name="line.104"></a>
<span class="sourceLineNo">105</span>    private char[] userPassword;<a name="line.105"></a>
<span class="sourceLineNo">106</span><a name="line.106"></a>
<span class="sourceLineNo">107</span>    /** Driver class name */<a name="line.107"></a>
<span class="sourceLineNo">108</span>    private String driver;<a name="line.108"></a>
<span class="sourceLineNo">109</span><a name="line.109"></a>
<span class="sourceLineNo">110</span>    /** Login TimeOut in seconds */<a name="line.110"></a>
<span class="sourceLineNo">111</span>    private int loginTimeout;<a name="line.111"></a>
<span class="sourceLineNo">112</span><a name="line.112"></a>
<span class="sourceLineNo">113</span>    /** Log stream. NOT USED */<a name="line.113"></a>
<span class="sourceLineNo">114</span>    private transient PrintWriter logWriter;<a name="line.114"></a>
<span class="sourceLineNo">115</span>    // PreparedStatement pool properties<a name="line.115"></a>
<span class="sourceLineNo">116</span>    private boolean poolPreparedStatements;<a name="line.116"></a>
<span class="sourceLineNo">117</span>    private int maxIdle = 10;<a name="line.117"></a>
<span class="sourceLineNo">118</span>    private long timeBetweenEvictionRunsMillis = BaseObjectPoolConfig.DEFAULT_TIME_BETWEEN_EVICTION_RUNS_MILLIS;<a name="line.118"></a>
<span class="sourceLineNo">119</span>    private int numTestsPerEvictionRun = -1;<a name="line.119"></a>
<span class="sourceLineNo">120</span>    private int minEvictableIdleTimeMillis = -1;<a name="line.120"></a>
<span class="sourceLineNo">121</span><a name="line.121"></a>
<span class="sourceLineNo">122</span>    private int maxPreparedStatements = -1;<a name="line.122"></a>
<span class="sourceLineNo">123</span><a name="line.123"></a>
<span class="sourceLineNo">124</span>    /** Whether or not getConnection has been called */<a name="line.124"></a>
<span class="sourceLineNo">125</span>    private volatile boolean getConnectionCalled;<a name="line.125"></a>
<span class="sourceLineNo">126</span><a name="line.126"></a>
<span class="sourceLineNo">127</span>    /** Connection properties passed to JDBC Driver */<a name="line.127"></a>
<span class="sourceLineNo">128</span>    private Properties connectionProperties;<a name="line.128"></a>
<span class="sourceLineNo">129</span><a name="line.129"></a>
<span class="sourceLineNo">130</span>    /**<a name="line.130"></a>
<span class="sourceLineNo">131</span>     * Controls access to the underlying connection<a name="line.131"></a>
<span class="sourceLineNo">132</span>     */<a name="line.132"></a>
<span class="sourceLineNo">133</span>    private boolean accessToUnderlyingConnectionAllowed;<a name="line.133"></a>
<span class="sourceLineNo">134</span><a name="line.134"></a>
<span class="sourceLineNo">135</span>    /**<a name="line.135"></a>
<span class="sourceLineNo">136</span>     * Default no-arg constructor for Serialization<a name="line.136"></a>
<span class="sourceLineNo">137</span>     */<a name="line.137"></a>
<span class="sourceLineNo">138</span>    public DriverAdapterCPDS() {<a name="line.138"></a>
<span class="sourceLineNo">139</span>    }<a name="line.139"></a>
<span class="sourceLineNo">140</span><a name="line.140"></a>
<span class="sourceLineNo">141</span>    /**<a name="line.141"></a>
<span class="sourceLineNo">142</span>     * Throws an IllegalStateException, if a PooledConnection has already been requested.<a name="line.142"></a>
<span class="sourceLineNo">143</span>     */<a name="line.143"></a>
<span class="sourceLineNo">144</span>    private void assertInitializationAllowed() throws IllegalStateException {<a name="line.144"></a>
<span class="sourceLineNo">145</span>        if (getConnectionCalled) {<a name="line.145"></a>
<span class="sourceLineNo">146</span>            throw new IllegalStateException(GET_CONNECTION_CALLED);<a name="line.146"></a>
<span class="sourceLineNo">147</span>        }<a name="line.147"></a>
<span class="sourceLineNo">148</span>    }<a name="line.148"></a>
<span class="sourceLineNo">149</span><a name="line.149"></a>
<span class="sourceLineNo">150</span>    private boolean getBooleanContentString(RefAddr ra) {<a name="line.150"></a>
<span class="sourceLineNo">151</span>        return Boolean.valueOf(getStringContent(ra)).booleanValue();<a name="line.151"></a>
<span class="sourceLineNo">152</span>    }<a name="line.152"></a>
<span class="sourceLineNo">153</span><a name="line.153"></a>
<span class="sourceLineNo">154</span>    /**<a name="line.154"></a>
<span class="sourceLineNo">155</span>     * Gets the connection properties passed to the JDBC driver.<a name="line.155"></a>
<span class="sourceLineNo">156</span>     *<a name="line.156"></a>
<span class="sourceLineNo">157</span>     * @return the JDBC connection properties used when creating connections.<a name="line.157"></a>
<span class="sourceLineNo">158</span>     */<a name="line.158"></a>
<span class="sourceLineNo">159</span>    public Properties getConnectionProperties() {<a name="line.159"></a>
<span class="sourceLineNo">160</span>        return connectionProperties;<a name="line.160"></a>
<span class="sourceLineNo">161</span>    }<a name="line.161"></a>
<span class="sourceLineNo">162</span><a name="line.162"></a>
<span class="sourceLineNo">163</span>    /**<a name="line.163"></a>
<span class="sourceLineNo">164</span>     * Gets the value of description. This property is here for use by the code which will deploy this datasource. It is<a name="line.164"></a>
<span class="sourceLineNo">165</span>     * not used internally.<a name="line.165"></a>
<span class="sourceLineNo">166</span>     *<a name="line.166"></a>
<span class="sourceLineNo">167</span>     * @return value of description, may be null.<a name="line.167"></a>
<span class="sourceLineNo">168</span>     * @see #setDescription(String)<a name="line.168"></a>
<span class="sourceLineNo">169</span>     */<a name="line.169"></a>
<span class="sourceLineNo">170</span>    public String getDescription() {<a name="line.170"></a>
<span class="sourceLineNo">171</span>        return description;<a name="line.171"></a>
<span class="sourceLineNo">172</span>    }<a name="line.172"></a>
<span class="sourceLineNo">173</span><a name="line.173"></a>
<span class="sourceLineNo">174</span>    /**<a name="line.174"></a>
<span class="sourceLineNo">175</span>     * Gets the driver class name.<a name="line.175"></a>
<span class="sourceLineNo">176</span>     *<a name="line.176"></a>
<span class="sourceLineNo">177</span>     * @return value of driver.<a name="line.177"></a>
<span class="sourceLineNo">178</span>     */<a name="line.178"></a>
<span class="sourceLineNo">179</span>    public String getDriver() {<a name="line.179"></a>
<span class="sourceLineNo">180</span>        return driver;<a name="line.180"></a>
<span class="sourceLineNo">181</span>    }<a name="line.181"></a>
<span class="sourceLineNo">182</span><a name="line.182"></a>
<span class="sourceLineNo">183</span>    private int getIntegerStringContent(final RefAddr ra) {<a name="line.183"></a>
<span class="sourceLineNo">184</span>        return Integer.parseInt(getStringContent(ra));<a name="line.184"></a>
<span class="sourceLineNo">185</span>    }<a name="line.185"></a>
<span class="sourceLineNo">186</span><a name="line.186"></a>
<span class="sourceLineNo">187</span>    /**<a name="line.187"></a>
<span class="sourceLineNo">188</span>     * Gets the maximum time in seconds that this data source can wait while attempting to connect to a database. NOT<a name="line.188"></a>
<span class="sourceLineNo">189</span>     * USED.<a name="line.189"></a>
<span class="sourceLineNo">190</span>     */<a name="line.190"></a>
<span class="sourceLineNo">191</span>    @Override<a name="line.191"></a>
<span class="sourceLineNo">192</span>    public int getLoginTimeout() {<a name="line.192"></a>
<span class="sourceLineNo">193</span>        return loginTimeout;<a name="line.193"></a>
<span class="sourceLineNo">194</span>    }<a name="line.194"></a>
<span class="sourceLineNo">195</span><a name="line.195"></a>
<span class="sourceLineNo">196</span>    /**<a name="line.196"></a>
<span class="sourceLineNo">197</span>     * Gets the log writer for this data source. NOT USED.<a name="line.197"></a>
<span class="sourceLineNo">198</span>     */<a name="line.198"></a>
<span class="sourceLineNo">199</span>    @Override<a name="line.199"></a>
<span class="sourceLineNo">200</span>    public PrintWriter getLogWriter() {<a name="line.200"></a>
<span class="sourceLineNo">201</span>        return logWriter;<a name="line.201"></a>
<span class="sourceLineNo">202</span>    }<a name="line.202"></a>
<span class="sourceLineNo">203</span><a name="line.203"></a>
<span class="sourceLineNo">204</span>    /**<a name="line.204"></a>
<span class="sourceLineNo">205</span>     * Gets the maximum number of statements that can remain idle in the pool, without extra ones being released, or<a name="line.205"></a>
<span class="sourceLineNo">206</span>     * negative for no limit.<a name="line.206"></a>
<span class="sourceLineNo">207</span>     *<a name="line.207"></a>
<span class="sourceLineNo">208</span>     * @return the value of maxIdle<a name="line.208"></a>
<span class="sourceLineNo">209</span>     */<a name="line.209"></a>
<span class="sourceLineNo">210</span>    public int getMaxIdle() {<a name="line.210"></a>
<span class="sourceLineNo">211</span>        return this.maxIdle;<a name="line.211"></a>
<span class="sourceLineNo">212</span>    }<a name="line.212"></a>
<span class="sourceLineNo">213</span><a name="line.213"></a>
<span class="sourceLineNo">214</span>    /**<a name="line.214"></a>
<span class="sourceLineNo">215</span>     * Gets the maximum number of prepared statements.<a name="line.215"></a>
<span class="sourceLineNo">216</span>     *<a name="line.216"></a>
<span class="sourceLineNo">217</span>     * @return maxPrepartedStatements value<a name="line.217"></a>
<span class="sourceLineNo">218</span>     */<a name="line.218"></a>
<span class="sourceLineNo">219</span>    public int getMaxPreparedStatements() {<a name="line.219"></a>
<span class="sourceLineNo">220</span>        return maxPreparedStatements;<a name="line.220"></a>
<span class="sourceLineNo">221</span>    }<a name="line.221"></a>
<span class="sourceLineNo">222</span><a name="line.222"></a>
<span class="sourceLineNo">223</span>    /**<a name="line.223"></a>
<span class="sourceLineNo">224</span>     * Gets the minimum amount of time a statement may sit idle in the pool before it is eligible for eviction by the<a name="line.224"></a>
<span class="sourceLineNo">225</span>     * idle object evictor (if any).<a name="line.225"></a>
<span class="sourceLineNo">226</span>     *<a name="line.226"></a>
<span class="sourceLineNo">227</span>     * @see #setMinEvictableIdleTimeMillis<a name="line.227"></a>
<span class="sourceLineNo">228</span>     * @see #setTimeBetweenEvictionRunsMillis<a name="line.228"></a>
<span class="sourceLineNo">229</span>     * @return the minimum amount of time a statement may sit idle in the pool.<a name="line.229"></a>
<span class="sourceLineNo">230</span>     */<a name="line.230"></a>
<span class="sourceLineNo">231</span>    public int getMinEvictableIdleTimeMillis() {<a name="line.231"></a>
<span class="sourceLineNo">232</span>        return minEvictableIdleTimeMillis;<a name="line.232"></a>
<span class="sourceLineNo">233</span>    }<a name="line.233"></a>
<span class="sourceLineNo">234</span><a name="line.234"></a>
<span class="sourceLineNo">235</span>    /**<a name="line.235"></a>
<span class="sourceLineNo">236</span>     * Gets the number of statements to examine during each run of the idle object evictor thread (if any.)<a name="line.236"></a>
<span class="sourceLineNo">237</span>     *<a name="line.237"></a>
<span class="sourceLineNo">238</span>     * @see #setNumTestsPerEvictionRun<a name="line.238"></a>
<span class="sourceLineNo">239</span>     * @see #setTimeBetweenEvictionRunsMillis<a name="line.239"></a>
<span class="sourceLineNo">240</span>     * @return the number of statements to examine during each run of the idle object evictor thread (if any.)<a name="line.240"></a>
<span class="sourceLineNo">241</span>     */<a name="line.241"></a>
<span class="sourceLineNo">242</span>    public int getNumTestsPerEvictionRun() {<a name="line.242"></a>
<span class="sourceLineNo">243</span>        return numTestsPerEvictionRun;<a name="line.243"></a>
<span class="sourceLineNo">244</span>    }<a name="line.244"></a>
<span class="sourceLineNo">245</span><a name="line.245"></a>
<span class="sourceLineNo">246</span>    /**<a name="line.246"></a>
<span class="sourceLineNo">247</span>     * Implements {@link ObjectFactory} to create an instance of this class<a name="line.247"></a>
<span class="sourceLineNo">248</span>     */<a name="line.248"></a>
<span class="sourceLineNo">249</span>    @Override<a name="line.249"></a>
<span class="sourceLineNo">250</span>    public Object getObjectInstance(final Object refObj, final Name name, final Context context,<a name="line.250"></a>
<span class="sourceLineNo">251</span>        final Hashtable&lt;?, ?&gt; env) throws Exception {<a name="line.251"></a>
<span class="sourceLineNo">252</span>        // The spec says to return null if we can't create an instance<a name="line.252"></a>
<span class="sourceLineNo">253</span>        // of the reference<a name="line.253"></a>
<span class="sourceLineNo">254</span>        DriverAdapterCPDS cpds = null;<a name="line.254"></a>
<span class="sourceLineNo">255</span>        if (refObj instanceof Reference) {<a name="line.255"></a>
<span class="sourceLineNo">256</span>            final Reference ref = (Reference) refObj;<a name="line.256"></a>
<span class="sourceLineNo">257</span>            if (ref.getClassName().equals(getClass().getName())) {<a name="line.257"></a>
<span class="sourceLineNo">258</span>                RefAddr ra = ref.get("description");<a name="line.258"></a>
<span class="sourceLineNo">259</span>                if (isNotEmpty(ra)) {<a name="line.259"></a>
<span class="sourceLineNo">260</span>                    setDescription(getStringContent(ra));<a name="line.260"></a>
<span class="sourceLineNo">261</span>                }<a name="line.261"></a>
<span class="sourceLineNo">262</span><a name="line.262"></a>
<span class="sourceLineNo">263</span>                ra = ref.get("driver");<a name="line.263"></a>
<span class="sourceLineNo">264</span>                if (isNotEmpty(ra)) {<a name="line.264"></a>
<span class="sourceLineNo">265</span>                    setDriver(getStringContent(ra));<a name="line.265"></a>
<span class="sourceLineNo">266</span>                }<a name="line.266"></a>
<span class="sourceLineNo">267</span>                ra = ref.get("url");<a name="line.267"></a>
<span class="sourceLineNo">268</span>                if (isNotEmpty(ra)) {<a name="line.268"></a>
<span class="sourceLineNo">269</span>                    setUrl(getStringContent(ra));<a name="line.269"></a>
<span class="sourceLineNo">270</span>                }<a name="line.270"></a>
<span class="sourceLineNo">271</span>                ra = ref.get(KEY_USER);<a name="line.271"></a>
<span class="sourceLineNo">272</span>                if (isNotEmpty(ra)) {<a name="line.272"></a>
<span class="sourceLineNo">273</span>                    setUser(getStringContent(ra));<a name="line.273"></a>
<span class="sourceLineNo">274</span>                }<a name="line.274"></a>
<span class="sourceLineNo">275</span>                ra = ref.get(KEY_PASSWORD);<a name="line.275"></a>
<span class="sourceLineNo">276</span>                if (isNotEmpty(ra)) {<a name="line.276"></a>
<span class="sourceLineNo">277</span>                    setPassword(getStringContent(ra));<a name="line.277"></a>
<span class="sourceLineNo">278</span>                }<a name="line.278"></a>
<span class="sourceLineNo">279</span><a name="line.279"></a>
<span class="sourceLineNo">280</span>                ra = ref.get("poolPreparedStatements");<a name="line.280"></a>
<span class="sourceLineNo">281</span>                if (isNotEmpty(ra)) {<a name="line.281"></a>
<span class="sourceLineNo">282</span>                    setPoolPreparedStatements(getBooleanContentString(ra));<a name="line.282"></a>
<span class="sourceLineNo">283</span>                }<a name="line.283"></a>
<span class="sourceLineNo">284</span>                ra = ref.get("maxIdle");<a name="line.284"></a>
<span class="sourceLineNo">285</span>                if (isNotEmpty(ra)) {<a name="line.285"></a>
<span class="sourceLineNo">286</span>                    setMaxIdle(getIntegerStringContent(ra));<a name="line.286"></a>
<span class="sourceLineNo">287</span>                }<a name="line.287"></a>
<span class="sourceLineNo">288</span><a name="line.288"></a>
<span class="sourceLineNo">289</span>                ra = ref.get("timeBetweenEvictionRunsMillis");<a name="line.289"></a>
<span class="sourceLineNo">290</span>                if (isNotEmpty(ra)) {<a name="line.290"></a>
<span class="sourceLineNo">291</span>                    setTimeBetweenEvictionRunsMillis(getIntegerStringContent(ra));<a name="line.291"></a>
<span class="sourceLineNo">292</span>                }<a name="line.292"></a>
<span class="sourceLineNo">293</span><a name="line.293"></a>
<span class="sourceLineNo">294</span>                ra = ref.get("numTestsPerEvictionRun");<a name="line.294"></a>
<span class="sourceLineNo">295</span>                if (isNotEmpty(ra)) {<a name="line.295"></a>
<span class="sourceLineNo">296</span>                    setNumTestsPerEvictionRun(getIntegerStringContent(ra));<a name="line.296"></a>
<span class="sourceLineNo">297</span>                }<a name="line.297"></a>
<span class="sourceLineNo">298</span><a name="line.298"></a>
<span class="sourceLineNo">299</span>                ra = ref.get("minEvictableIdleTimeMillis");<a name="line.299"></a>
<span class="sourceLineNo">300</span>                if (isNotEmpty(ra)) {<a name="line.300"></a>
<span class="sourceLineNo">301</span>                    setMinEvictableIdleTimeMillis(getIntegerStringContent(ra));<a name="line.301"></a>
<span class="sourceLineNo">302</span>                }<a name="line.302"></a>
<span class="sourceLineNo">303</span>                ra = ref.get("maxPreparedStatements");<a name="line.303"></a>
<span class="sourceLineNo">304</span>                if (isNotEmpty(ra)) {<a name="line.304"></a>
<span class="sourceLineNo">305</span>                    setMaxPreparedStatements(getIntegerStringContent(ra));<a name="line.305"></a>
<span class="sourceLineNo">306</span>                }<a name="line.306"></a>
<span class="sourceLineNo">307</span><a name="line.307"></a>
<span class="sourceLineNo">308</span>                ra = ref.get("accessToUnderlyingConnectionAllowed");<a name="line.308"></a>
<span class="sourceLineNo">309</span>                if (isNotEmpty(ra)) {<a name="line.309"></a>
<span class="sourceLineNo">310</span>                    setAccessToUnderlyingConnectionAllowed(getBooleanContentString(ra));<a name="line.310"></a>
<span class="sourceLineNo">311</span>                }<a name="line.311"></a>
<span class="sourceLineNo">312</span><a name="line.312"></a>
<span class="sourceLineNo">313</span>                cpds = this;<a name="line.313"></a>
<span class="sourceLineNo">314</span>            }<a name="line.314"></a>
<span class="sourceLineNo">315</span>        }<a name="line.315"></a>
<span class="sourceLineNo">316</span>        return cpds;<a name="line.316"></a>
<span class="sourceLineNo">317</span>    }<a name="line.317"></a>
<span class="sourceLineNo">318</span><a name="line.318"></a>
<span class="sourceLineNo">319</span>    @Override<a name="line.319"></a>
<span class="sourceLineNo">320</span>    public Logger getParentLogger() throws SQLFeatureNotSupportedException {<a name="line.320"></a>
<span class="sourceLineNo">321</span>        throw new SQLFeatureNotSupportedException();<a name="line.321"></a>
<span class="sourceLineNo">322</span>    }<a name="line.322"></a>
<span class="sourceLineNo">323</span><a name="line.323"></a>
<span class="sourceLineNo">324</span>    /**<a name="line.324"></a>
<span class="sourceLineNo">325</span>     * Gets the value of password for the default user.<a name="line.325"></a>
<span class="sourceLineNo">326</span>     *<a name="line.326"></a>
<span class="sourceLineNo">327</span>     * @return value of password.<a name="line.327"></a>
<span class="sourceLineNo">328</span>     */<a name="line.328"></a>
<span class="sourceLineNo">329</span>    public String getPassword() {<a name="line.329"></a>
<span class="sourceLineNo">330</span>        return Utils.toString(userPassword);<a name="line.330"></a>
<span class="sourceLineNo">331</span>    }<a name="line.331"></a>
<span class="sourceLineNo">332</span><a name="line.332"></a>
<span class="sourceLineNo">333</span>    /**<a name="line.333"></a>
<span class="sourceLineNo">334</span>     * Gets the value of password for the default user.<a name="line.334"></a>
<span class="sourceLineNo">335</span>     *<a name="line.335"></a>
<span class="sourceLineNo">336</span>     * @return value of password.<a name="line.336"></a>
<span class="sourceLineNo">337</span>     * @since 2.4.0<a name="line.337"></a>
<span class="sourceLineNo">338</span>     */<a name="line.338"></a>
<span class="sourceLineNo">339</span>    public char[] getPasswordCharArray() {<a name="line.339"></a>
<span class="sourceLineNo">340</span>        return userPassword;<a name="line.340"></a>
<span class="sourceLineNo">341</span>    }<a name="line.341"></a>
<span class="sourceLineNo">342</span><a name="line.342"></a>
<span class="sourceLineNo">343</span>    /**<a name="line.343"></a>
<span class="sourceLineNo">344</span>     * Attempts to establish a database connection using the default user and password.<a name="line.344"></a>
<span class="sourceLineNo">345</span>     */<a name="line.345"></a>
<span class="sourceLineNo">346</span>    @Override<a name="line.346"></a>
<span class="sourceLineNo">347</span>    public PooledConnection getPooledConnection() throws SQLException {<a name="line.347"></a>
<span class="sourceLineNo">348</span>        return getPooledConnection(getUser(), getPassword());<a name="line.348"></a>
<span class="sourceLineNo">349</span>    }<a name="line.349"></a>
<span class="sourceLineNo">350</span><a name="line.350"></a>
<span class="sourceLineNo">351</span>    /**<a name="line.351"></a>
<span class="sourceLineNo">352</span>     * Attempts to establish a database connection.<a name="line.352"></a>
<span class="sourceLineNo">353</span>     *<a name="line.353"></a>
<span class="sourceLineNo">354</span>     * @param pooledUserName name to be used for the connection<a name="line.354"></a>
<span class="sourceLineNo">355</span>     * @param pooledUserPassword password to be used fur the connection<a name="line.355"></a>
<span class="sourceLineNo">356</span>     */<a name="line.356"></a>
<span class="sourceLineNo">357</span>    @Override<a name="line.357"></a>
<span class="sourceLineNo">358</span>    public PooledConnection getPooledConnection(final String pooledUserName, final String pooledUserPassword)<a name="line.358"></a>
<span class="sourceLineNo">359</span>        throws SQLException {<a name="line.359"></a>
<span class="sourceLineNo">360</span>        getConnectionCalled = true;<a name="line.360"></a>
<span class="sourceLineNo">361</span>        PooledConnectionImpl pooledConnection = null;<a name="line.361"></a>
<span class="sourceLineNo">362</span>        // Workaround for buggy WebLogic 5.1 classloader - ignore the exception upon first invocation.<a name="line.362"></a>
<span class="sourceLineNo">363</span>        try {<a name="line.363"></a>
<span class="sourceLineNo">364</span>            if (connectionProperties != null) {<a name="line.364"></a>
<span class="sourceLineNo">365</span>                update(connectionProperties, KEY_USER, pooledUserName);<a name="line.365"></a>
<span class="sourceLineNo">366</span>                update(connectionProperties, KEY_PASSWORD, pooledUserPassword);<a name="line.366"></a>
<span class="sourceLineNo">367</span>                pooledConnection = new PooledConnectionImpl(<a name="line.367"></a>
<span class="sourceLineNo">368</span>                    DriverManager.getConnection(getUrl(), connectionProperties));<a name="line.368"></a>
<span class="sourceLineNo">369</span>            } else {<a name="line.369"></a>
<span class="sourceLineNo">370</span>                pooledConnection = new PooledConnectionImpl(<a name="line.370"></a>
<span class="sourceLineNo">371</span>                    DriverManager.getConnection(getUrl(), pooledUserName, pooledUserPassword));<a name="line.371"></a>
<span class="sourceLineNo">372</span>            }<a name="line.372"></a>
<span class="sourceLineNo">373</span>            pooledConnection.setAccessToUnderlyingConnectionAllowed(isAccessToUnderlyingConnectionAllowed());<a name="line.373"></a>
<span class="sourceLineNo">374</span>        } catch (final ClassCircularityError e) {<a name="line.374"></a>
<span class="sourceLineNo">375</span>            if (connectionProperties != null) {<a name="line.375"></a>
<span class="sourceLineNo">376</span>                pooledConnection = new PooledConnectionImpl(<a name="line.376"></a>
<span class="sourceLineNo">377</span>                    DriverManager.getConnection(getUrl(), connectionProperties));<a name="line.377"></a>
<span class="sourceLineNo">378</span>            } else {<a name="line.378"></a>
<span class="sourceLineNo">379</span>                pooledConnection = new PooledConnectionImpl(<a name="line.379"></a>
<span class="sourceLineNo">380</span>                    DriverManager.getConnection(getUrl(), pooledUserName, pooledUserPassword));<a name="line.380"></a>
<span class="sourceLineNo">381</span>            }<a name="line.381"></a>
<span class="sourceLineNo">382</span>            pooledConnection.setAccessToUnderlyingConnectionAllowed(isAccessToUnderlyingConnectionAllowed());<a name="line.382"></a>
<span class="sourceLineNo">383</span>        }<a name="line.383"></a>
<span class="sourceLineNo">384</span>        KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; stmtPool = null;<a name="line.384"></a>
<span class="sourceLineNo">385</span>        if (isPoolPreparedStatements()) {<a name="line.385"></a>
<span class="sourceLineNo">386</span>            final GenericKeyedObjectPoolConfig&lt;DelegatingPreparedStatement&gt; config = new GenericKeyedObjectPoolConfig&lt;&gt;();<a name="line.386"></a>
<span class="sourceLineNo">387</span>            config.setMaxTotalPerKey(Integer.MAX_VALUE);<a name="line.387"></a>
<span class="sourceLineNo">388</span>            config.setBlockWhenExhausted(false);<a name="line.388"></a>
<span class="sourceLineNo">389</span>            config.setMaxWaitMillis(0);<a name="line.389"></a>
<span class="sourceLineNo">390</span>            config.setMaxIdlePerKey(getMaxIdle());<a name="line.390"></a>
<span class="sourceLineNo">391</span>            if (getMaxPreparedStatements() &lt;= 0) {<a name="line.391"></a>
<span class="sourceLineNo">392</span>                // since there is no limit, create a prepared statement pool with an eviction thread;<a name="line.392"></a>
<span class="sourceLineNo">393</span>                // evictor settings are the same as the connection pool settings.<a name="line.393"></a>
<span class="sourceLineNo">394</span>                config.setTimeBetweenEvictionRunsMillis(getTimeBetweenEvictionRunsMillis());<a name="line.394"></a>
<span class="sourceLineNo">395</span>                config.setNumTestsPerEvictionRun(getNumTestsPerEvictionRun());<a name="line.395"></a>
<span class="sourceLineNo">396</span>                config.setMinEvictableIdleTimeMillis(getMinEvictableIdleTimeMillis());<a name="line.396"></a>
<span class="sourceLineNo">397</span>            } else {<a name="line.397"></a>
<span class="sourceLineNo">398</span>                // since there is a limit, create a prepared statement pool without an eviction thread;<a name="line.398"></a>
<span class="sourceLineNo">399</span>                // pool has LRU functionality so when the limit is reached, 15% of the pool is cleared.<a name="line.399"></a>
<span class="sourceLineNo">400</span>                // see org.apache.commons.pool2.impl.GenericKeyedObjectPool.clearOldest method<a name="line.400"></a>
<span class="sourceLineNo">401</span>                config.setMaxTotal(getMaxPreparedStatements());<a name="line.401"></a>
<span class="sourceLineNo">402</span>                config.setTimeBetweenEvictionRunsMillis(-1);<a name="line.402"></a>
<span class="sourceLineNo">403</span>                config.setNumTestsPerEvictionRun(0);<a name="line.403"></a>
<span class="sourceLineNo">404</span>                config.setMinEvictableIdleTimeMillis(0);<a name="line.404"></a>
<span class="sourceLineNo">405</span>            }<a name="line.405"></a>
<span class="sourceLineNo">406</span>            stmtPool = new GenericKeyedObjectPool&lt;&gt;(pooledConnection, config);<a name="line.406"></a>
<span class="sourceLineNo">407</span>            pooledConnection.setStatementPool(stmtPool);<a name="line.407"></a>
<span class="sourceLineNo">408</span>        }<a name="line.408"></a>
<span class="sourceLineNo">409</span>        return pooledConnection;<a name="line.409"></a>
<span class="sourceLineNo">410</span>    }<a name="line.410"></a>
<span class="sourceLineNo">411</span><a name="line.411"></a>
<span class="sourceLineNo">412</span>    /**<a name="line.412"></a>
<span class="sourceLineNo">413</span>     * Implements {@link Referenceable}.<a name="line.413"></a>
<span class="sourceLineNo">414</span>     */<a name="line.414"></a>
<span class="sourceLineNo">415</span>    @Override<a name="line.415"></a>
<span class="sourceLineNo">416</span>    public Reference getReference() throws NamingException {<a name="line.416"></a>
<span class="sourceLineNo">417</span>        // this class implements its own factory<a name="line.417"></a>
<span class="sourceLineNo">418</span>        final String factory = getClass().getName();<a name="line.418"></a>
<span class="sourceLineNo">419</span><a name="line.419"></a>
<span class="sourceLineNo">420</span>        final Reference ref = new Reference(getClass().getName(), factory, null);<a name="line.420"></a>
<span class="sourceLineNo">421</span><a name="line.421"></a>
<span class="sourceLineNo">422</span>        ref.add(new StringRefAddr("description", getDescription()));<a name="line.422"></a>
<span class="sourceLineNo">423</span>        ref.add(new StringRefAddr("driver", getDriver()));<a name="line.423"></a>
<span class="sourceLineNo">424</span>        ref.add(new StringRefAddr("loginTimeout", String.valueOf(getLoginTimeout())));<a name="line.424"></a>
<span class="sourceLineNo">425</span>        ref.add(new StringRefAddr(KEY_PASSWORD, getPassword()));<a name="line.425"></a>
<span class="sourceLineNo">426</span>        ref.add(new StringRefAddr(KEY_USER, getUser()));<a name="line.426"></a>
<span class="sourceLineNo">427</span>        ref.add(new StringRefAddr("url", getUrl()));<a name="line.427"></a>
<span class="sourceLineNo">428</span><a name="line.428"></a>
<span class="sourceLineNo">429</span>        ref.add(new StringRefAddr("poolPreparedStatements", String.valueOf(isPoolPreparedStatements())));<a name="line.429"></a>
<span class="sourceLineNo">430</span>        ref.add(new StringRefAddr("maxIdle", String.valueOf(getMaxIdle())));<a name="line.430"></a>
<span class="sourceLineNo">431</span>        ref.add(new StringRefAddr("timeBetweenEvictionRunsMillis", String.valueOf(getTimeBetweenEvictionRunsMillis())));<a name="line.431"></a>
<span class="sourceLineNo">432</span>        ref.add(new StringRefAddr("numTestsPerEvictionRun", String.valueOf(getNumTestsPerEvictionRun())));<a name="line.432"></a>
<span class="sourceLineNo">433</span>        ref.add(new StringRefAddr("minEvictableIdleTimeMillis", String.valueOf(getMinEvictableIdleTimeMillis())));<a name="line.433"></a>
<span class="sourceLineNo">434</span>        ref.add(new StringRefAddr("maxPreparedStatements", String.valueOf(getMaxPreparedStatements())));<a name="line.434"></a>
<span class="sourceLineNo">435</span><a name="line.435"></a>
<span class="sourceLineNo">436</span>        return ref;<a name="line.436"></a>
<span class="sourceLineNo">437</span>    }<a name="line.437"></a>
<span class="sourceLineNo">438</span><a name="line.438"></a>
<span class="sourceLineNo">439</span>    private String getStringContent(RefAddr ra) {<a name="line.439"></a>
<span class="sourceLineNo">440</span>        return ra.getContent().toString();<a name="line.440"></a>
<span class="sourceLineNo">441</span>    }<a name="line.441"></a>
<span class="sourceLineNo">442</span><a name="line.442"></a>
<span class="sourceLineNo">443</span>    /**<a name="line.443"></a>
<span class="sourceLineNo">444</span>     * Gets the number of milliseconds to sleep between runs of the idle object evictor thread. When non-positive, no<a name="line.444"></a>
<span class="sourceLineNo">445</span>     * idle object evictor thread will be run.<a name="line.445"></a>
<span class="sourceLineNo">446</span>     *<a name="line.446"></a>
<span class="sourceLineNo">447</span>     * @return the value of the evictor thread timer<a name="line.447"></a>
<span class="sourceLineNo">448</span>     * @see #setTimeBetweenEvictionRunsMillis(long)<a name="line.448"></a>
<span class="sourceLineNo">449</span>     */<a name="line.449"></a>
<span class="sourceLineNo">450</span>    public long getTimeBetweenEvictionRunsMillis() {<a name="line.450"></a>
<span class="sourceLineNo">451</span>        return timeBetweenEvictionRunsMillis;<a name="line.451"></a>
<span class="sourceLineNo">452</span>    }<a name="line.452"></a>
<span class="sourceLineNo">453</span><a name="line.453"></a>
<span class="sourceLineNo">454</span>    /**<a name="line.454"></a>
<span class="sourceLineNo">455</span>     * Gets the value of url used to locate the database for this datasource.<a name="line.455"></a>
<span class="sourceLineNo">456</span>     *<a name="line.456"></a>
<span class="sourceLineNo">457</span>     * @return value of url.<a name="line.457"></a>
<span class="sourceLineNo">458</span>     */<a name="line.458"></a>
<span class="sourceLineNo">459</span>    public String getUrl() {<a name="line.459"></a>
<span class="sourceLineNo">460</span>        return url;<a name="line.460"></a>
<span class="sourceLineNo">461</span>    }<a name="line.461"></a>
<span class="sourceLineNo">462</span><a name="line.462"></a>
<span class="sourceLineNo">463</span>    /**<a name="line.463"></a>
<span class="sourceLineNo">464</span>     * Gets the value of default user (login or user name).<a name="line.464"></a>
<span class="sourceLineNo">465</span>     *<a name="line.465"></a>
<span class="sourceLineNo">466</span>     * @return value of user.<a name="line.466"></a>
<span class="sourceLineNo">467</span>     */<a name="line.467"></a>
<span class="sourceLineNo">468</span>    public String getUser() {<a name="line.468"></a>
<span class="sourceLineNo">469</span>        return userName;<a name="line.469"></a>
<span class="sourceLineNo">470</span>    }<a name="line.470"></a>
<span class="sourceLineNo">471</span><a name="line.471"></a>
<span class="sourceLineNo">472</span>    /**<a name="line.472"></a>
<span class="sourceLineNo">473</span>     * Returns the value of the accessToUnderlyingConnectionAllowed property.<a name="line.473"></a>
<span class="sourceLineNo">474</span>     *<a name="line.474"></a>
<span class="sourceLineNo">475</span>     * @return true if access to the underlying is allowed, false otherwise.<a name="line.475"></a>
<span class="sourceLineNo">476</span>     */<a name="line.476"></a>
<span class="sourceLineNo">477</span>    public synchronized boolean isAccessToUnderlyingConnectionAllowed() {<a name="line.477"></a>
<span class="sourceLineNo">478</span>        return this.accessToUnderlyingConnectionAllowed;<a name="line.478"></a>
<span class="sourceLineNo">479</span>    }<a name="line.479"></a>
<span class="sourceLineNo">480</span><a name="line.480"></a>
<span class="sourceLineNo">481</span>    private boolean isNotEmpty(RefAddr ra) {<a name="line.481"></a>
<span class="sourceLineNo">482</span>        return ra != null &amp;&amp; ra.getContent() != null;<a name="line.482"></a>
<span class="sourceLineNo">483</span>    }<a name="line.483"></a>
<span class="sourceLineNo">484</span><a name="line.484"></a>
<span class="sourceLineNo">485</span>    /**<a name="line.485"></a>
<span class="sourceLineNo">486</span>     * Whether to toggle the pooling of &lt;code&gt;PreparedStatement&lt;/code&gt;s<a name="line.486"></a>
<span class="sourceLineNo">487</span>     *<a name="line.487"></a>
<span class="sourceLineNo">488</span>     * @return value of poolPreparedStatements.<a name="line.488"></a>
<span class="sourceLineNo">489</span>     */<a name="line.489"></a>
<span class="sourceLineNo">490</span>    public boolean isPoolPreparedStatements() {<a name="line.490"></a>
<span class="sourceLineNo">491</span>        return poolPreparedStatements;<a name="line.491"></a>
<span class="sourceLineNo">492</span>    }<a name="line.492"></a>
<span class="sourceLineNo">493</span><a name="line.493"></a>
<span class="sourceLineNo">494</span>    /**<a name="line.494"></a>
<span class="sourceLineNo">495</span>     * Sets the value of the accessToUnderlyingConnectionAllowed property. It controls if the PoolGuard allows access to<a name="line.495"></a>
<span class="sourceLineNo">496</span>     * the underlying connection. (Default: false)<a name="line.496"></a>
<span class="sourceLineNo">497</span>     *<a name="line.497"></a>
<span class="sourceLineNo">498</span>     * @param allow Access to the underlying connection is granted when true.<a name="line.498"></a>
<span class="sourceLineNo">499</span>     */<a name="line.499"></a>
<span class="sourceLineNo">500</span>    public synchronized void setAccessToUnderlyingConnectionAllowed(final boolean allow) {<a name="line.500"></a>
<span class="sourceLineNo">501</span>        this.accessToUnderlyingConnectionAllowed = allow;<a name="line.501"></a>
<span class="sourceLineNo">502</span>    }<a name="line.502"></a>
<span class="sourceLineNo">503</span><a name="line.503"></a>
<span class="sourceLineNo">504</span>    /**<a name="line.504"></a>
<span class="sourceLineNo">505</span>     * Sets the connection properties passed to the JDBC driver.<a name="line.505"></a>
<span class="sourceLineNo">506</span>     * &lt;p&gt;<a name="line.506"></a>
<span class="sourceLineNo">507</span>     * If &lt;code&gt;props&lt;/code&gt; contains "user" and/or "password" properties, the corresponding instance properties are<a name="line.507"></a>
<span class="sourceLineNo">508</span>     * set. If these properties are not present, they are filled in using {@link #getUser()}, {@link #getPassword()}<a name="line.508"></a>
<span class="sourceLineNo">509</span>     * when {@link #getPooledConnection()} is called, or using the actual parameters to the method call when<a name="line.509"></a>
<span class="sourceLineNo">510</span>     * {@link #getPooledConnection(String, String)} is called. Calls to {@link #setUser(String)} or<a name="line.510"></a>
<span class="sourceLineNo">511</span>     * {@link #setPassword(String)} overwrite the values of these properties if &lt;code&gt;connectionProperties&lt;/code&gt; is not<a name="line.511"></a>
<span class="sourceLineNo">512</span>     * null.<a name="line.512"></a>
<span class="sourceLineNo">513</span>     * &lt;/p&gt;<a name="line.513"></a>
<span class="sourceLineNo">514</span>     *<a name="line.514"></a>
<span class="sourceLineNo">515</span>     * @param props Connection properties to use when creating new connections.<a name="line.515"></a>
<span class="sourceLineNo">516</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.516"></a>
<span class="sourceLineNo">517</span>     */<a name="line.517"></a>
<span class="sourceLineNo">518</span>    public void setConnectionProperties(final Properties props) {<a name="line.518"></a>
<span class="sourceLineNo">519</span>        assertInitializationAllowed();<a name="line.519"></a>
<span class="sourceLineNo">520</span>        connectionProperties = props;<a name="line.520"></a>
<span class="sourceLineNo">521</span>        if (connectionProperties != null) {<a name="line.521"></a>
<span class="sourceLineNo">522</span>            if (connectionProperties.containsKey(KEY_USER)) {<a name="line.522"></a>
<span class="sourceLineNo">523</span>                setUser(connectionProperties.getProperty(KEY_USER));<a name="line.523"></a>
<span class="sourceLineNo">524</span>            }<a name="line.524"></a>
<span class="sourceLineNo">525</span>            if (connectionProperties.containsKey(KEY_PASSWORD)) {<a name="line.525"></a>
<span class="sourceLineNo">526</span>                setPassword(connectionProperties.getProperty(KEY_PASSWORD));<a name="line.526"></a>
<span class="sourceLineNo">527</span>            }<a name="line.527"></a>
<span class="sourceLineNo">528</span>        }<a name="line.528"></a>
<span class="sourceLineNo">529</span>    }<a name="line.529"></a>
<span class="sourceLineNo">530</span><a name="line.530"></a>
<span class="sourceLineNo">531</span>    /**<a name="line.531"></a>
<span class="sourceLineNo">532</span>     * Sets the value of description. This property is here for use by the code which will deploy this datasource. It is<a name="line.532"></a>
<span class="sourceLineNo">533</span>     * not used internally.<a name="line.533"></a>
<span class="sourceLineNo">534</span>     *<a name="line.534"></a>
<span class="sourceLineNo">535</span>     * @param v Value to assign to description.<a name="line.535"></a>
<span class="sourceLineNo">536</span>     */<a name="line.536"></a>
<span class="sourceLineNo">537</span>    public void setDescription(final String v) {<a name="line.537"></a>
<span class="sourceLineNo">538</span>        this.description = v;<a name="line.538"></a>
<span class="sourceLineNo">539</span>    }<a name="line.539"></a>
<span class="sourceLineNo">540</span><a name="line.540"></a>
<span class="sourceLineNo">541</span>    /**<a name="line.541"></a>
<span class="sourceLineNo">542</span>     * Sets the driver class name. Setting the driver class name cause the driver to be registered with the<a name="line.542"></a>
<span class="sourceLineNo">543</span>     * DriverManager.<a name="line.543"></a>
<span class="sourceLineNo">544</span>     *<a name="line.544"></a>
<span class="sourceLineNo">545</span>     * @param v Value to assign to driver.<a name="line.545"></a>
<span class="sourceLineNo">546</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.546"></a>
<span class="sourceLineNo">547</span>     * @throws ClassNotFoundException if the class cannot be located<a name="line.547"></a>
<span class="sourceLineNo">548</span>     */<a name="line.548"></a>
<span class="sourceLineNo">549</span>    public void setDriver(final String v) throws ClassNotFoundException {<a name="line.549"></a>
<span class="sourceLineNo">550</span>        assertInitializationAllowed();<a name="line.550"></a>
<span class="sourceLineNo">551</span>        this.driver = v;<a name="line.551"></a>
<span class="sourceLineNo">552</span>        // make sure driver is registered<a name="line.552"></a>
<span class="sourceLineNo">553</span>        Class.forName(v);<a name="line.553"></a>
<span class="sourceLineNo">554</span>    }<a name="line.554"></a>
<span class="sourceLineNo">555</span><a name="line.555"></a>
<span class="sourceLineNo">556</span>    /**<a name="line.556"></a>
<span class="sourceLineNo">557</span>     * Sets the maximum time in seconds that this data source will wait while attempting to connect to a database. NOT<a name="line.557"></a>
<span class="sourceLineNo">558</span>     * USED.<a name="line.558"></a>
<span class="sourceLineNo">559</span>     */<a name="line.559"></a>
<span class="sourceLineNo">560</span>    @Override<a name="line.560"></a>
<span class="sourceLineNo">561</span>    public void setLoginTimeout(final int seconds) {<a name="line.561"></a>
<span class="sourceLineNo">562</span>        loginTimeout = seconds;<a name="line.562"></a>
<span class="sourceLineNo">563</span>    }<a name="line.563"></a>
<span class="sourceLineNo">564</span><a name="line.564"></a>
<span class="sourceLineNo">565</span>    /**<a name="line.565"></a>
<span class="sourceLineNo">566</span>     * Sets the log writer for this data source. NOT USED.<a name="line.566"></a>
<span class="sourceLineNo">567</span>     */<a name="line.567"></a>
<span class="sourceLineNo">568</span>    @Override<a name="line.568"></a>
<span class="sourceLineNo">569</span>    public void setLogWriter(final PrintWriter out) {<a name="line.569"></a>
<span class="sourceLineNo">570</span>        logWriter = out;<a name="line.570"></a>
<span class="sourceLineNo">571</span>    }<a name="line.571"></a>
<span class="sourceLineNo">572</span><a name="line.572"></a>
<span class="sourceLineNo">573</span>    /**<a name="line.573"></a>
<span class="sourceLineNo">574</span>     * Gets the maximum number of statements that can remain idle in the pool, without extra ones being released, or<a name="line.574"></a>
<span class="sourceLineNo">575</span>     * negative for no limit.<a name="line.575"></a>
<span class="sourceLineNo">576</span>     *<a name="line.576"></a>
<span class="sourceLineNo">577</span>     * @param maxIdle The maximum number of statements that can remain idle<a name="line.577"></a>
<span class="sourceLineNo">578</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.578"></a>
<span class="sourceLineNo">579</span>     */<a name="line.579"></a>
<span class="sourceLineNo">580</span>    public void setMaxIdle(final int maxIdle) {<a name="line.580"></a>
<span class="sourceLineNo">581</span>        assertInitializationAllowed();<a name="line.581"></a>
<span class="sourceLineNo">582</span>        this.maxIdle = maxIdle;<a name="line.582"></a>
<span class="sourceLineNo">583</span>    }<a name="line.583"></a>
<span class="sourceLineNo">584</span><a name="line.584"></a>
<span class="sourceLineNo">585</span>    /**<a name="line.585"></a>
<span class="sourceLineNo">586</span>     * Sets the maximum number of prepared statements.<a name="line.586"></a>
<span class="sourceLineNo">587</span>     *<a name="line.587"></a>
<span class="sourceLineNo">588</span>     * @param maxPreparedStatements the new maximum number of prepared statements<a name="line.588"></a>
<span class="sourceLineNo">589</span>     */<a name="line.589"></a>
<span class="sourceLineNo">590</span>    public void setMaxPreparedStatements(final int maxPreparedStatements) {<a name="line.590"></a>
<span class="sourceLineNo">591</span>        this.maxPreparedStatements = maxPreparedStatements;<a name="line.591"></a>
<span class="sourceLineNo">592</span>    }<a name="line.592"></a>
<span class="sourceLineNo">593</span><a name="line.593"></a>
<span class="sourceLineNo">594</span>    /**<a name="line.594"></a>
<span class="sourceLineNo">595</span>     * Sets the minimum amount of time a statement may sit idle in the pool before it is eligible for eviction by the<a name="line.595"></a>
<span class="sourceLineNo">596</span>     * idle object evictor (if any). When non-positive, no objects will be evicted from the pool due to idle time alone.<a name="line.596"></a>
<span class="sourceLineNo">597</span>     *<a name="line.597"></a>
<span class="sourceLineNo">598</span>     * @param minEvictableIdleTimeMillis minimum time to set (in ms)<a name="line.598"></a>
<span class="sourceLineNo">599</span>     * @see #getMinEvictableIdleTimeMillis()<a name="line.599"></a>
<span class="sourceLineNo">600</span>     * @see #setTimeBetweenEvictionRunsMillis(long)<a name="line.600"></a>
<span class="sourceLineNo">601</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.601"></a>
<span class="sourceLineNo">602</span>     */<a name="line.602"></a>
<span class="sourceLineNo">603</span>    public void setMinEvictableIdleTimeMillis(final int minEvictableIdleTimeMillis) {<a name="line.603"></a>
<span class="sourceLineNo">604</span>        assertInitializationAllowed();<a name="line.604"></a>
<span class="sourceLineNo">605</span>        this.minEvictableIdleTimeMillis = minEvictableIdleTimeMillis;<a name="line.605"></a>
<span class="sourceLineNo">606</span>    }<a name="line.606"></a>
<span class="sourceLineNo">607</span><a name="line.607"></a>
<span class="sourceLineNo">608</span>    /**<a name="line.608"></a>
<span class="sourceLineNo">609</span>     * Sets the number of statements to examine during each run of the idle object evictor thread (if any).<a name="line.609"></a>
<span class="sourceLineNo">610</span>     * &lt;p&gt;<a name="line.610"></a>
<span class="sourceLineNo">611</span>     * When a negative value is supplied,<a name="line.611"></a>
<span class="sourceLineNo">612</span>     * &lt;code&gt;ceil({@link BasicDataSource#getNumIdle})/abs({@link #getNumTestsPerEvictionRun})&lt;/code&gt; tests will be run.<a name="line.612"></a>
<span class="sourceLineNo">613</span>     * I.e., when the value is &lt;i&gt;-n&lt;/i&gt;, roughly one &lt;i&gt;n&lt;/i&gt;th of the idle objects will be tested per run.<a name="line.613"></a>
<span class="sourceLineNo">614</span>     * &lt;/p&gt;<a name="line.614"></a>
<span class="sourceLineNo">615</span>     *<a name="line.615"></a>
<span class="sourceLineNo">616</span>     * @param numTestsPerEvictionRun number of statements to examine per run<a name="line.616"></a>
<span class="sourceLineNo">617</span>     * @see #getNumTestsPerEvictionRun()<a name="line.617"></a>
<span class="sourceLineNo">618</span>     * @see #setTimeBetweenEvictionRunsMillis(long)<a name="line.618"></a>
<span class="sourceLineNo">619</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.619"></a>
<span class="sourceLineNo">620</span>     */<a name="line.620"></a>
<span class="sourceLineNo">621</span>    public void setNumTestsPerEvictionRun(final int numTestsPerEvictionRun) {<a name="line.621"></a>
<span class="sourceLineNo">622</span>        assertInitializationAllowed();<a name="line.622"></a>
<span class="sourceLineNo">623</span>        this.numTestsPerEvictionRun = numTestsPerEvictionRun;<a name="line.623"></a>
<span class="sourceLineNo">624</span>    }<a name="line.624"></a>
<span class="sourceLineNo">625</span><a name="line.625"></a>
<span class="sourceLineNo">626</span>    /**<a name="line.626"></a>
<span class="sourceLineNo">627</span>     * Sets the value of password for the default user.<a name="line.627"></a>
<span class="sourceLineNo">628</span>     *<a name="line.628"></a>
<span class="sourceLineNo">629</span>     * @param userPassword Value to assign to password.<a name="line.629"></a>
<span class="sourceLineNo">630</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.630"></a>
<span class="sourceLineNo">631</span>     */<a name="line.631"></a>
<span class="sourceLineNo">632</span>    public void setPassword(final char[] userPassword) {<a name="line.632"></a>
<span class="sourceLineNo">633</span>        assertInitializationAllowed();<a name="line.633"></a>
<span class="sourceLineNo">634</span>        this.userPassword = Utils.clone(userPassword);<a name="line.634"></a>
<span class="sourceLineNo">635</span>        update(connectionProperties, KEY_PASSWORD, Utils.toString(this.userPassword));<a name="line.635"></a>
<span class="sourceLineNo">636</span>    }<a name="line.636"></a>
<span class="sourceLineNo">637</span><a name="line.637"></a>
<span class="sourceLineNo">638</span>    /**<a name="line.638"></a>
<span class="sourceLineNo">639</span>     * Sets the value of password for the default user.<a name="line.639"></a>
<span class="sourceLineNo">640</span>     *<a name="line.640"></a>
<span class="sourceLineNo">641</span>     * @param userPassword Value to assign to password.<a name="line.641"></a>
<span class="sourceLineNo">642</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.642"></a>
<span class="sourceLineNo">643</span>     */<a name="line.643"></a>
<span class="sourceLineNo">644</span>    public void setPassword(final String userPassword) {<a name="line.644"></a>
<span class="sourceLineNo">645</span>        assertInitializationAllowed();<a name="line.645"></a>
<span class="sourceLineNo">646</span>        this.userPassword = Utils.toCharArray(userPassword);<a name="line.646"></a>
<span class="sourceLineNo">647</span>        update(connectionProperties, KEY_PASSWORD, userPassword);<a name="line.647"></a>
<span class="sourceLineNo">648</span>    }<a name="line.648"></a>
<span class="sourceLineNo">649</span><a name="line.649"></a>
<span class="sourceLineNo">650</span>    /**<a name="line.650"></a>
<span class="sourceLineNo">651</span>     * Whether to toggle the pooling of &lt;code&gt;PreparedStatement&lt;/code&gt;s<a name="line.651"></a>
<span class="sourceLineNo">652</span>     *<a name="line.652"></a>
<span class="sourceLineNo">653</span>     * @param poolPreparedStatements true to pool statements.<a name="line.653"></a>
<span class="sourceLineNo">654</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.654"></a>
<span class="sourceLineNo">655</span>     */<a name="line.655"></a>
<span class="sourceLineNo">656</span>    public void setPoolPreparedStatements(final boolean poolPreparedStatements) {<a name="line.656"></a>
<span class="sourceLineNo">657</span>        assertInitializationAllowed();<a name="line.657"></a>
<span class="sourceLineNo">658</span>        this.poolPreparedStatements = poolPreparedStatements;<a name="line.658"></a>
<span class="sourceLineNo">659</span>    }<a name="line.659"></a>
<span class="sourceLineNo">660</span><a name="line.660"></a>
<span class="sourceLineNo">661</span>    /**<a name="line.661"></a>
<span class="sourceLineNo">662</span>     * Sets the number of milliseconds to sleep between runs of the idle object evictor thread. When non-positive, no<a name="line.662"></a>
<span class="sourceLineNo">663</span>     * idle object evictor thread will be run.<a name="line.663"></a>
<span class="sourceLineNo">664</span>     *<a name="line.664"></a>
<span class="sourceLineNo">665</span>     * @param timeBetweenEvictionRunsMillis The number of milliseconds to sleep between runs of the idle object evictor<a name="line.665"></a>
<span class="sourceLineNo">666</span>     *        thread. When non-positive, no idle object evictor thread will be run.<a name="line.666"></a>
<span class="sourceLineNo">667</span>     * @see #getTimeBetweenEvictionRunsMillis()<a name="line.667"></a>
<span class="sourceLineNo">668</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.668"></a>
<span class="sourceLineNo">669</span>     */<a name="line.669"></a>
<span class="sourceLineNo">670</span>    public void setTimeBetweenEvictionRunsMillis(final long timeBetweenEvictionRunsMillis) {<a name="line.670"></a>
<span class="sourceLineNo">671</span>        assertInitializationAllowed();<a name="line.671"></a>
<span class="sourceLineNo">672</span>        this.timeBetweenEvictionRunsMillis = timeBetweenEvictionRunsMillis;<a name="line.672"></a>
<span class="sourceLineNo">673</span>    }<a name="line.673"></a>
<span class="sourceLineNo">674</span><a name="line.674"></a>
<span class="sourceLineNo">675</span>    /**<a name="line.675"></a>
<span class="sourceLineNo">676</span>     * Sets the value of URL string used to locate the database for this datasource.<a name="line.676"></a>
<span class="sourceLineNo">677</span>     *<a name="line.677"></a>
<span class="sourceLineNo">678</span>     * @param v Value to assign to url.<a name="line.678"></a>
<span class="sourceLineNo">679</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.679"></a>
<span class="sourceLineNo">680</span>     */<a name="line.680"></a>
<span class="sourceLineNo">681</span>    public void setUrl(final String v) {<a name="line.681"></a>
<span class="sourceLineNo">682</span>        assertInitializationAllowed();<a name="line.682"></a>
<span class="sourceLineNo">683</span>        this.url = v;<a name="line.683"></a>
<span class="sourceLineNo">684</span>    }<a name="line.684"></a>
<span class="sourceLineNo">685</span><a name="line.685"></a>
<span class="sourceLineNo">686</span>    /**<a name="line.686"></a>
<span class="sourceLineNo">687</span>     * Sets the value of default user (login or user name).<a name="line.687"></a>
<span class="sourceLineNo">688</span>     *<a name="line.688"></a>
<span class="sourceLineNo">689</span>     * @param v Value to assign to user.<a name="line.689"></a>
<span class="sourceLineNo">690</span>     * @throws IllegalStateException if {@link #getPooledConnection()} has been called<a name="line.690"></a>
<span class="sourceLineNo">691</span>     */<a name="line.691"></a>
<span class="sourceLineNo">692</span>    public void setUser(final String v) {<a name="line.692"></a>
<span class="sourceLineNo">693</span>        assertInitializationAllowed();<a name="line.693"></a>
<span class="sourceLineNo">694</span>        this.userName = v;<a name="line.694"></a>
<span class="sourceLineNo">695</span>        update(connectionProperties, KEY_USER, v);<a name="line.695"></a>
<span class="sourceLineNo">696</span>    }<a name="line.696"></a>
<span class="sourceLineNo">697</span><a name="line.697"></a>
<span class="sourceLineNo">698</span>    /**<a name="line.698"></a>
<span class="sourceLineNo">699</span>     * Does not print the userName and userPassword field nor the 'user' or 'password' in the connectionProperties.<a name="line.699"></a>
<span class="sourceLineNo">700</span>     *<a name="line.700"></a>
<span class="sourceLineNo">701</span>     * @since 2.6.0<a name="line.701"></a>
<span class="sourceLineNo">702</span>     */<a name="line.702"></a>
<span class="sourceLineNo">703</span>    @Override<a name="line.703"></a>
<span class="sourceLineNo">704</span>    public synchronized String toString() {<a name="line.704"></a>
<span class="sourceLineNo">705</span>        final StringBuilder builder = new StringBuilder(super.toString());<a name="line.705"></a>
<span class="sourceLineNo">706</span>        builder.append("[description=");<a name="line.706"></a>
<span class="sourceLineNo">707</span>        builder.append(description);<a name="line.707"></a>
<span class="sourceLineNo">708</span>        builder.append(", url=");<a name="line.708"></a>
<span class="sourceLineNo">709</span>        // TODO What if the connection string contains a 'user' or 'password' query parameter but that connection string<a name="line.709"></a>
<span class="sourceLineNo">710</span>        // is not in a legal URL format?<a name="line.710"></a>
<span class="sourceLineNo">711</span>        builder.append(url);<a name="line.711"></a>
<span class="sourceLineNo">712</span>        builder.append(", driver=");<a name="line.712"></a>
<span class="sourceLineNo">713</span>        builder.append(driver);<a name="line.713"></a>
<span class="sourceLineNo">714</span>        builder.append(", loginTimeout=");<a name="line.714"></a>
<span class="sourceLineNo">715</span>        builder.append(loginTimeout);<a name="line.715"></a>
<span class="sourceLineNo">716</span>        builder.append(", poolPreparedStatements=");<a name="line.716"></a>
<span class="sourceLineNo">717</span>        builder.append(poolPreparedStatements);<a name="line.717"></a>
<span class="sourceLineNo">718</span>        builder.append(", maxIdle=");<a name="line.718"></a>
<span class="sourceLineNo">719</span>        builder.append(maxIdle);<a name="line.719"></a>
<span class="sourceLineNo">720</span>        builder.append(", timeBetweenEvictionRunsMillis=");<a name="line.720"></a>
<span class="sourceLineNo">721</span>        builder.append(timeBetweenEvictionRunsMillis);<a name="line.721"></a>
<span class="sourceLineNo">722</span>        builder.append(", numTestsPerEvictionRun=");<a name="line.722"></a>
<span class="sourceLineNo">723</span>        builder.append(numTestsPerEvictionRun);<a name="line.723"></a>
<span class="sourceLineNo">724</span>        builder.append(", minEvictableIdleTimeMillis=");<a name="line.724"></a>
<span class="sourceLineNo">725</span>        builder.append(minEvictableIdleTimeMillis);<a name="line.725"></a>
<span class="sourceLineNo">726</span>        builder.append(", maxPreparedStatements=");<a name="line.726"></a>
<span class="sourceLineNo">727</span>        builder.append(maxPreparedStatements);<a name="line.727"></a>
<span class="sourceLineNo">728</span>        builder.append(", getConnectionCalled=");<a name="line.728"></a>
<span class="sourceLineNo">729</span>        builder.append(getConnectionCalled);<a name="line.729"></a>
<span class="sourceLineNo">730</span>        builder.append(", connectionProperties=");<a name="line.730"></a>
<span class="sourceLineNo">731</span>        builder.append(Utils.cloneWithoutCredentials(connectionProperties));<a name="line.731"></a>
<span class="sourceLineNo">732</span>        builder.append(", accessToUnderlyingConnectionAllowed=");<a name="line.732"></a>
<span class="sourceLineNo">733</span>        builder.append(accessToUnderlyingConnectionAllowed);<a name="line.733"></a>
<span class="sourceLineNo">734</span>        builder.append("]");<a name="line.734"></a>
<span class="sourceLineNo">735</span>        return builder.toString();<a name="line.735"></a>
<span class="sourceLineNo">736</span>    }<a name="line.736"></a>
<span class="sourceLineNo">737</span><a name="line.737"></a>
<span class="sourceLineNo">738</span>    private void update(final Properties properties, final String key, final String value) {<a name="line.738"></a>
<span class="sourceLineNo">739</span>        if (properties != null &amp;&amp; key != null) {<a name="line.739"></a>
<span class="sourceLineNo">740</span>            if (value == null) {<a name="line.740"></a>
<span class="sourceLineNo">741</span>                properties.remove(key);<a name="line.741"></a>
<span class="sourceLineNo">742</span>            } else {<a name="line.742"></a>
<span class="sourceLineNo">743</span>                properties.setProperty(key, value);<a name="line.743"></a>
<span class="sourceLineNo">744</span>            }<a name="line.744"></a>
<span class="sourceLineNo">745</span>        }<a name="line.745"></a>
<span class="sourceLineNo">746</span>    }<a name="line.746"></a>
<span class="sourceLineNo">747</span>}<a name="line.747"></a>




























































</pre>
</div>
</body>
</html>
